/*
 * ising.c - visualization of ising spins in an N x N lattice
 *
 * ... actually N x M
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "dfbapi.h"

#define X 200
#define Y 200
#define MAX_T 100

int main(int argc, char **argv)
{
 unsigned char *atom;
 char *arg_v[4];
 char m_text[30];
 char t_text[30];
 char b_text[30];
 int max_x,x_c,max_y,y_c;
 int i;
 int count_p;
 unsigned int T;
 double S;
 int M;
 double beta;
 double delta_e;

 /* random stuff*/
 srand(time(0));

 /* display stuff */
 d2_lattice d2_l;

 /* we will parse argv later ... */
 max_x=X;
 max_y=Y;

 d2_lattice_init(&argc,argv,&d2_l,max_x,max_y);

 atom=(unsigned char *)(malloc(max_x*max_y*sizeof(unsigned char)));
 
 d2_l.status=atom;
 
 /* begin at T=0 M=1 situation */
 memset(atom,0,max_x*max_y*sizeof(unsigned char));

 S=1; /* i have no idea! */
 
 for(T=1;T<MAX_T;T++)
 {
  beta=20.0/T; /* k_B = 1 */
  /* do 10 itterations, we will need more */
  for(i=0;i<10;i++)
  {

 for(x_c=0;x_c<max_x;x_c++)
 {
  for(y_c=0;y_c<max_y;y_c++)
  {
   count_p=0;
   M=0;
   if((*(atom+x_c+((2*y_c+1)%max_y)*max_x))&1) ++count_p;
   if((*(atom+x_c+((2*y_c-1)%max_y)*max_x))&1) ++count_p;
   if((*(atom+((2*x_c+1)%max_x)+y_c*max_x))&1) ++count_p;
   if((*(atom+((2*x_c-1)%max_x)+y_c*max_x))&1) ++count_p;
   if(((*(atom+x_c+y_c*max_x))&1)==0) count_p=4-count_p;
   delta_e=(2*count_p-4)*S;
   if(delta_e<0) *(atom+x_c+y_c*max_x)=(*(atom+x_c+y_c*max_x)+1)&1;
   else
   {
    if(1.0*rand()/RAND_MAX<exp(-1.0*delta_e*beta))
     *(atom+x_c+y_c*max_x)=(*(atom+x_c+y_c*max_x)+1)&1;
   }
   if((*(atom+x_c+((2*y_c+1)%max_y)*max_x))&1) ++M;
  }
 }
  sprintf(t_text,"T = %d",T);
  arg_v[1]=t_text;
  sprintf(b_text,"b = %f",beta);
  arg_v[2]=b_text;
  sprintf(m_text,"M = %f",1.0-2.0*M/(max_x*max_y));
  arg_v[3]=m_text;
  d2_lattice_draw(&d2_l,0,0,3,arg_v);
  }
 }

 getchar();

 return 1;
}
